/*** 2SUP5.C ***/

extern unsigned _stklen = 10000;

#define float long double

#include "GRAFICOS.C"
#include "ESCONDID.C"

float f1(float u, float v) { return v + 4*sin(u); }
float f2(float u, float v) { return 1.5*v ; }
float f3(float u, float v) { return 5 + v + 4*cos(u) ; }

float g1(float u, float v) { return u; }
float g2(float u, float v) { return v; }
float g3(float u, float v) { return 9 - u*u/5 - v*v/5; }

int pontos_descartados = 0;
#define MAX_IT 100

#include "SIS.C"
#include "INTERS1.C"

char nome_arquivo[80] = "2SUP5";

void main(int argc) {

  int cor_f1_1 = BLACK, cor_f1_2 = BLACK,
      cor_f2_1 = BLACK, cor_f2_2 = BLACK,
      cor1_1 = RED, cor1_2 = CYAN,
      cor2_1 = BLACK, cor2_2 = BLACK,
      cor3_1 = RED, cor3_2 = CYAN,
      cor4_1 = BLACK, cor4_2 = BLACK,
      padrao1_1 = 255, padrao1_2 = 255,
      padrao2_1 = 85, padrao2_2 = 85,
      opcao = -1;
  float umin1 = -3.14, umax1 = 3.14, vmin1 = -7.5, vmax1 = 7.5,
	umin2 = -7.5, umax2 = 7.5, vmin2 = -7.5, vmax2 = 7.5;

  IniciaModoGrafico();
  o1 = 2; o2 = 1; o3 = 0.5;
  DeterminaPlanoDeProjecao();
  A = getmaxx()/4;
  B = getmaxy()/2;
  TAM = 20;
  nu = 45; nv = 45;
  Desenha2SuperficiesEsc(f1, f2, f3, umin1, umax1, vmin1, vmax1, cor_f1_1,
    cor_f2_1, cor1_1, cor2_1, cor3_1, cor4_1, padrao1_1, padrao2_1,
    g1, g2, g3, umin2, umax2, vmin2, vmax2, cor_f1_2, cor_f2_2, cor1_2,
    cor2_2, cor3_2, cor4_2, padrao1_2, padrao2_2, nome_arquivo, opcao);

  A = 3*getmaxx()/4;
  B = getmaxy()/2;
  nu = 15; nv = 15; inc = 0.008;
  setcolor(RED);
  DesenhaSuperficie2(f1, f2, f3, umin1, umax1, vmin1, vmax1);
  setcolor(BLUE);
  DesenhaSuperficie2(g1, g2, g3, umin2, umax2, vmin2, vmax2);
  setcolor(YELLOW);
  InterceptaSup2(f1, f2, f3, g1, g2, g3, umin1, umax1, vmin1, vmax1, 1, 1, 1);
  InterceptaSup2(f1, f2, f3, g1, g2, g3, umin2, umax2, vmin2, vmax2, -1, -1, -1);

  SalvaImagem(nome_arquivo);
  if (argc == 1) {
    getch();
    closegraph();
  }
}

/*** FIM DE 2SUP5.C ***/
